/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.geometries.viewer3d.controls.light_editor;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.jogamp.vecmath.Color3f;
import org.visnow.vn.geometries.viewer3d.lights.EditableDirectionalLight;
import org.visnow.vn.gui.icons.IconsContainer;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class DirectionalLightEditor extends javax.swing.JPanel
{

    private int iEditor;
    private EditableDirectionalLight light = null;
    private DirectionalLightsEditorPanel parentPanel = null;

    /**
     * Creates new form DirectionalLightEditor
     */
    public DirectionalLightEditor()
    {
        initComponents();
        lightColorEditor.addChangeListener(new ChangeListener()
        {
            public void stateChanged(ChangeEvent e)
            {
                if (light != null)
                    light.setLightColor(new Color3f(lightColorEditor.getColorComponents()));
            }
        });
        lightTypeButton.setIcons(
            new Icon[]{new ImageIcon(IconsContainer.getBallBlack()),
                       new ImageIcon(IconsContainer.getBallBlue1()),
                       new ImageIcon(IconsContainer.getBallBlue2())});
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        directionEditToggle = new javax.swing.JToggleButton();
        jButton1 = new javax.swing.JButton();
        lightColorEditor = new org.visnow.vn.geometries.viewer3d.controls.light_editor.LightColorEditor();
        lightTypeButton = new org.visnow.vn.gui.widgets.MultistateButton();

        setMinimumSize(new java.awt.Dimension(180, 24));
        setPreferredSize(new java.awt.Dimension(220, 24));
        setLayout(new java.awt.GridBagLayout());

        directionEditToggle.setFont(new java.awt.Font("Dialog", 0, 12));
        directionEditToggle.setText("direction");
        directionEditToggle.setBorder(null);
        directionEditToggle.setMargin(new java.awt.Insets(3, 1, 3, 1));
        directionEditToggle.setMaximumSize(new java.awt.Dimension(56, 22));
        directionEditToggle.setMinimumSize(new java.awt.Dimension(56, 22));
        directionEditToggle.setName("directionEditToggle"); // NOI18N
        directionEditToggle.setOpaque(false);
        directionEditToggle.setPreferredSize(new java.awt.Dimension(56, 22));
        directionEditToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                directionEditToggleActionPerformed(evt);
            }
        });
        add(directionEditToggle, new java.awt.GridBagConstraints());

        jButton1.setFont(new java.awt.Font("Dialog", 0, 12));
        jButton1.setText("*");
        jButton1.setBorder(null);
        jButton1.setMargin(new java.awt.Insets(2, 6, 2, 2));
        jButton1.setMaximumSize(new java.awt.Dimension(21, 21));
        jButton1.setMinimumSize(new java.awt.Dimension(21, 21));
        jButton1.setName("jButton1"); // NOI18N
        jButton1.setPreferredSize(new java.awt.Dimension(21, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.PAGE_END;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 0, 0);
        add(jButton1, gridBagConstraints);

        lightColorEditor.setMinimumSize(new java.awt.Dimension(60, 22));
        lightColorEditor.setName("lightColorEditor"); // NOI18N
        lightColorEditor.setPreferredSize(new java.awt.Dimension(100, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 0, 0);
        add(lightColorEditor, gridBagConstraints);

        lightTypeButton.setText("multistateButton1");
        lightTypeButton.setMaximumSize(new java.awt.Dimension(26, 26));
        lightTypeButton.setMinimumSize(new java.awt.Dimension(26, 26));
        lightTypeButton.setName("lightTypeButton"); // NOI18N
        lightTypeButton.setPreferredSize(new java.awt.Dimension(26, 26));
        lightTypeButton.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                lightTypeButtonStateChanged(evt);
            }
        });
        add(lightTypeButton, new java.awt.GridBagConstraints());
    }// </editor-fold>//GEN-END:initComponents

    private void directionEditToggleActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_directionEditToggleActionPerformed
    {//GEN-HEADEREND:event_directionEditToggleActionPerformed
        if (parentPanel != null)
            parentPanel.changeDirectionEdit(iEditor, directionEditToggle.isSelected());
    }//GEN-LAST:event_directionEditToggleActionPerformed

    private void lightTypeButtonStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_lightTypeButtonStateChanged
    {//GEN-HEADEREND:event_lightTypeButtonStateChanged
        if (light != null)
            light.setState(lightTypeButton.getState());
    }//GEN-LAST:event_lightTypeButtonStateChanged

    public void setiEditor(int iEditor)
    {
        this.iEditor = iEditor;
    }

    public void setLight(EditableDirectionalLight light)
    {
        this.light = light;
        lightColorEditor.setLight(light);
        lightTypeButton.setState(light.getState());
    }

    public void setParentPanel(DirectionalLightsEditorPanel parentPanel)
    {
        this.parentPanel = parentPanel;
    }

    public void unsetDirectionEdit()
    {
        directionEditToggle.setSelected(false);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JToggleButton directionEditToggle;
    protected javax.swing.JButton jButton1;
    protected org.visnow.vn.geometries.viewer3d.controls.light_editor.LightColorEditor lightColorEditor;
    protected org.visnow.vn.gui.widgets.MultistateButton lightTypeButton;
    // End of variables declaration//GEN-END:variables
}
